/*
    Copyright (C) 2005-2010  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <glib.h>
#include "nntpgrab_utils.h"

static GMainLoop *mainloop = NULL;

static gboolean
idle_func(gpointer data)
{
    // This function is necessary to prevent the GLib mainloop from eating 100% CPU usage
    g_usleep(G_USEC_PER_SEC / 10);

    if (!mainloop) {
        return FALSE;
    }

    return TRUE;
}

void
ng_event_handler_loop_run(void)
{
    g_return_if_fail(mainloop == NULL);

    mainloop = g_main_loop_new(NULL, FALSE);
    g_idle_add(idle_func, NULL);
    g_main_loop_run(mainloop);
}

void
ng_event_handler_loop_quit(void)
{
    g_return_if_fail(mainloop != NULL);

    g_main_loop_quit(mainloop);
    g_main_loop_unref(mainloop);
    mainloop = NULL;
}

int
ng_event_handler_loop_depth(void)
{
    return g_main_depth();
}
