#include "DialogSetCollectionName.h"
#include "ui_DialogSetCollectionName.h"

DialogSetCollectionName::DialogSetCollectionName(QNNTPGrabGlue *glue, QString collection_name, QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogSetCollectionName)
{
    this->glue = glue;
    ui->setupUi(this);

    ui->editCollectionName->setText(collection_name);

    QList<QNNTPGrabGlue::Collection> collections = glue->schedularGetAllTasks();
    QNNTPGrabGlue::Collection collection;

    Q_FOREACH(collection, collections) {
        ui->comboCollectionName->addItem(collection.collection_name);
    }
}

DialogSetCollectionName::~DialogSetCollectionName()
{
    delete ui;
}

QString DialogSetCollectionName::getCollectionName(void)
{
    if (ui->editCollectionName->isEnabled()) {
        return ui->editCollectionName->text();
    } else {
        return ui->comboCollectionName->currentText();
    }
}
