#include "ProgressBarDelegateDownloadQueue.h"

#include <QStyleOptionProgressBarV2>
#include <QStyle>
#include <QApplication>
#include <assert.h>

#ifdef Q_OS_MACX
#include <QCleanlooksStyle>
#endif

ProgressBarDelegateDownloadQueue::ProgressBarDelegateDownloadQueue(QObject *parent)
	: QItemDelegate(parent)
{

}

ProgressBarDelegateDownloadQueue::~ProgressBarDelegateDownloadQueue()
{

}

QSize ProgressBarDelegateDownloadQueue::sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const
{
    QString txt = index.model()->data(index, Qt::DisplayRole).toString();

    if (txt.isEmpty()) {
        return QSize(60,16);
    } else {
        return QSize(100,16);
    }
}

void ProgressBarDelegateDownloadQueue::paint(QPainter* painter, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
        QStyleOptionProgressBarV2 opts;
        int value = index.model()->data(index.sibling(index.row(), 9), Qt::DisplayRole).toInt();
        QString txt = index.model()->data(index, Qt::DisplayRole).toString();

        if (txt.isEmpty()) {
            txt = QString ("%1%").arg(value);
        }

        opts.state = QStyle::State_Active | QStyle::State_Enabled;
        opts.text = txt;
        opts.maximum = 100;
        opts.minimum =   0;
        opts.progress = value;
        opts.rect = option.rect;
        opts.rect.setRight(option.rect.right()-1);
        opts.rect.setHeight(option.rect.height()-1);
        opts.textVisible = true;
        opts.textAlignment = Qt::AlignCenter;
#ifdef Q_OS_MACX
        QCleanlooksStyle s;
        s.drawControl(QCleanlooksStyle::CE_ProgressBar, &opts, painter, 0);
#else
        QApplication::style()->drawControl(QStyle::CE_ProgressBar, &opts, painter);
#endif
}
