#ifndef WIDGETCONFIG_H
#define WIDGETCONFIG_H

#include <QObject>
#include <QListWidget>


#include <QNNTPGrabGlue.h>
#include "WidgetConfigServers.h"
#include "WidgetConfigFolders.h"
#include "WidgetConfigNotifications.h"
#include "WidgetConfigPAR2.h"
#include "WidgetConfigDisplay.h"
#include "WidgetConfigNZBCreator.h"
#include "WidgetConfigAutoImport.h"
#include "WidgetConfigPlugins.h"

namespace Ui {
    class WidgetConfig;
}

class WidgetConfig : public QWidget
{
    Q_OBJECT;

public:
    WidgetConfig(QNNTPGrabGlue *glue, QWidget *parent = 0);
    ~WidgetConfig();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::WidgetConfig *ui;
    QNNTPGrabGlue *glue;

    WidgetConfigServers *servers;
    WidgetConfigFolders *folders;
    WidgetConfigNotifications *notifications;
    WidgetConfigPAR2 *par2;
    WidgetConfigDisplay *display;
    WidgetConfigNZBCreator *nzbcreator;
    WidgetConfigAutoImport *auto_import;
    WidgetConfigPlugins *plugins;

private slots:
    void on_listWidgetConfig_currentRowChanged(int currentRow);
};

#endif // WIDGETCONFIG_H
