#ifndef WIDGETCONFIGSERVERS_H
#define WIDGETCONFIGSERVERS_H

#include <QWidget>
#include <QNNTPGrabGlue.h>
#include <QTreeWidgetItem>

namespace Ui {
    class WidgetConfigServers;
}

class WidgetConfigServers : public QWidget {
    Q_OBJECT
public:
    WidgetConfigServers(QNNTPGrabGlue *glue, QWidget *parent = 0);
    ~WidgetConfigServers();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::WidgetConfigServers *ui;
    QNNTPGrabGlue *glue;
    void UpdateServers();

private slots:
    void on_treeWidget_itemClicked(QTreeWidgetItem* item, int column);
    void on_treeWidget_itemDoubleClicked(QTreeWidgetItem* item, int column);
    void on_treeWidget_itemSelectionChanged();
    void onConfigChanged();
    void on_btnApplyBandwidthLimiting_clicked();
    void on_btnEditServer_clicked();
    void on_btnRemoveServer_clicked();
    void on_btnAddServer_clicked();
    void chkEnableBandwidthLimiting_toggled(bool toggled);

};

#endif // WIDGETCONFIGSERVERS_H
