#ifndef WIDGETCONNECTIONS_H
#define WIDGETCONNECTIONS_H

#include <QWidget>
#include <QNNTPGrabGlue.h>
#include "ProgressBarDelegate.h"

namespace Ui {
    class WidgetConnections;
}

class WidgetConnections : public QWidget {
    Q_OBJECT
public:
    WidgetConnections(QNNTPGrabGlue *glue, QWidget *parent = 0);
    ~WidgetConnections();

protected:
    void changeEvent(QEvent *e);
    void timerEvent(QTimerEvent *event);

private:
    Ui::WidgetConnections *ui;
    QNNTPGrabGlue *glue;
    int num_disconnected_connections;
    ProgressBarDelegate *progressbarDelegate;

private slots:
    void onConfigChanged();
    void onConnectionConnecting(QString servername, int conn_id);
    void onConnectionConnected(QString servername, int conn_id, QString welcome_msg);
    void onConnectionDisconnect(QString servername, int conn_id, QNNTPGrabGlue::NNTPDisconnectType disconnect_type, QString reason);
    void onPartDownloadStart(QString servername, int conn_id, QString collection_name, QString subject ,int part_num);
    void onPartProgressUpdate(QString servername, int conn_id, QString collection_name, QString subject, int part_num, int bytes_downloaded, int bytes_total);
    void onPartDone(QString servername, int conn_id, QString collection_name, QString subject, int part_num, int size);
    void onPartFailed(QString servername, int conn_id, QString collection_name, QString subject, int part_num, int size, bool all_servers_tried);
};

#endif // WIDGETCONNECTIONS_H
