#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QNNTPGrabGlue.h>
#include "WidgetUpdateInfo.h"
#include "WidgetConfig.h"
#include "WidgetDownloadQueue.h"
#include "WidgetNZBCreator.h"
#include "WidgetRepairAndUnpack.h"
#include "WidgetTrafficMonitor.h"
#include "WidgetConnections.h"

#include "FormDebug.h"

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QNNTPGrabGlue *glue, QWidget *parent = 0);
    ~MainWindow();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;
    QNNTPGrabGlue *glue;

    WidgetUpdateInfo *updateInfoWidget;
    WidgetConfig *configWidget;
    WidgetDownloadQueue *downloadQueueWidget;
    WidgetNZBCreator *nzbcreatorWidget;
    WidgetRepairAndUnpack *repairAndUnpackWidget;

    WidgetTrafficMonitor *trafficMonitorWidget;
    WidgetConnections *connectionsWidget;

    FormDebug *formDebug;

private slots:
    void actionImportNZB_activated(void);
    void actionDonate_activated(void);
    void actionEnableAutomaticShutdown_activated(void);
    void actionManagePlugins_activated(void);
    void actionShowDebugWindow_activated(void);
    void actionPauseDownloadQueue_activated(void);

    void onSchedularStateChanged(QNNTPGrabGlue::SchedularState state, QString reason);
};

#endif // MAINWINDOW_H
